;********************************************************
;*														*
;*	      		Hopping Code Ƶ{					*
;*							&							*
;*   	     	Hopping Code ѱKƵ{					*
;*														*
;********************************************************
;
#include <p16f877.inc>
;
; ΰƵ{Τܼƪŧi
;
			global	RECEIVE
			global	DECRYPT
			global	KEY0,KEY1,KEY2,KEY3,KEY4,KEY5,KEY6,KEY7
			global	CSR0,CSR1,CSR2,CSR3,CSR4,CSR5,CSR6,CSR7,CSR8
;
#define		HOP1	CSR0				; wq HOP1~4  CSR1~4
#define		HOP2	CSR1
#define		HOP3	CSR2
#define		HOP4	CSR3

#define		KEELOQ_IN	PORTC,0			; wq Hopping Code HJ}
#define		MAX_CODE_LENGTH	.72
#define		CODE_LENGTH	.66
;
 	 		UDATA_SHR					; Difine CSR0:CSR7 on Share memory 	 
CSR0		res	1						; Hopping Code xsȦs (LSB)
CSR1		res	1
CSR2		res	1
CSR3		res	1
CSR4		res	1
CSR5		res	1
CSR6		res	1
CSR7		res	1
CSR8		res	1						; Hopping Code xsȦs (MSB)
;
Encrypt_Data	UDATA	0x20
KEY0		res	1						; 64-bit ѱK (LSB)
KEY1		res	1
KEY2		res	1
KEY3		res	1
KEY4		res	1
KEY5		res	1
KEY6		res	1
KEY7		res	1
;
		UDATA
CNT0		res	1
CNT1		res	1
HOP_LENGTH	res	1
MASK		res	1
KEELOQ_Temp	res	1
;
;
KEELOQ_CODE	CODE
;
;*************************************************************************
;*	RECEIVE() : Keeloq Ƶ{ 
;* Ƶ{ϥ4MHz _WvA{㦳۰ʳtvPվC
;* tviq 240uS to 680uS (зǳtv TE=400uS)C
;*
;*	pƥTL~A䵲G|xsbȦsCSR0 ~CSR8Fæ^W=01C
;*      pƤΦ~AW Ȧs|^0 (w=00)AܱѡC
;*************************************************************************
;
RECEIVE
			BANKSEL	CNT0				;
			clrf	CNT0				; Normal is Low on Keeloq input pin
			btfsc	KEELOQ_IN			; Is KEELOQ_IN = High ??
			goto	GO_Calibrate		; Yes, Goto Calibrate portion
;
SEE_FIRST_HIGH							; Check Low period is over 700uS? 
 			nop							; [1]		8 Cycles = 8uS at @4MHz
			nop							; [2]
			nop							; [3]
			goto	$+1					; [5]
			incf	CNT0,F				; [6]		8uS*128=1024Us
			btfsc	CNT0,6				; [8]  		Is Low Time Exceed 700uS 
			goto	RECEIVE_Fail		;   		Don't care this Instruction when Count The Time		 					
			btfss	KEELOQ_IN			; [9]		Is KEELOQ_IN = High now ??
			goto	SEE_FIRST_HIGH		; [11]		No! Check again !!			
;
GO_Calibrate							; Start to Check hi signal of Preamble 
		clrf	CNT0					; Check Proamble High period is over 700uS?
Cal_1									;  
			nop							; [1]
			nop							; [2]
			goto	$+1					; [4]
			btfss	KEELOQ_IN			; [6] 		KEELOQ_IN = LOW ?
			goto	Cal_2				; 		Yes , goto Cal_2
			incf	CNT0,F				; [7]	No, Increase CNT0
			btfsc	CNT0,6				; [9] 	High Time Exceed 700uS
			goto	RECEIVE_Fail		; 		Yes , Receive Fail " Return 0 "
			goto	Cal_1				; [11]	No,   Continue to Sample KEELOQ_IN
;
Cal_2							
			clrf	CNT0
			clrf	CNT1
Cal_3
										; 	Check Sync Header period is over 7.68mS?
										; 	Loop Time =  10uS @4MHz ,
			btfsc	KEELOQ_IN			; [2]KEELOQ_IN = 0
			goto	Calcute_TE			; 	KEELOQ_IN=1 , Calcute the Length of TE
			incf	CNT0,F				; [3]CNT0=255 then loop time = 2.55mS
			btfsc	STATUS,Z			; [5]CNT0 Overflow ??
			incf	CNT1,F				;  	Yes ! CNT1 + 1
			movf	CNT1,W				; [6]
			sublw	.2					; [7]CNT1 >= 2 ?
			btfsc	STATUS,C			; [8]10 - W , if CNT1 < 10 then C=1
			goto	Cal_3				; [10]No , Sample Again !!
			goto	RECEIVE_Fail		; 	CNT1 >2 , Low Period is over 7.68mS 
;
RECEIVE_Fail
			bcf		STATUS,C
			retlw	0x00
;
;******************************************************************************
;****	Calctue the SYNC Header period of KEELOQ_IN
;****	Receive Fail if The time less than 2.55 ms 
;******************************************************************************
Calcute_TE		
			movf	CNT1,W
			sublw	.0					; Check CNT1=0 ? IF =0 Low Period is under 2.55mS, Fail Receive.
			btfsc	STATUS,Z
			goto	GO_Calibrate		; Fail Low period, It is not a SYNC Header (2.6mS-6.6mS)
;		
			bcf		STATUS,C			; Divided by 8
			RRF		CNT1,F
			RRF		CNT0,F
			bcf		STATUS,C
			RRF		CNT1,F
			RRF		CNT0,F
			bcf		STATUS,C
			RRF		CNT1,F
			RRF		CNT0,F			

;******************************************************************************
; Now !! The TE is stored to CNT0 with 4 us Base
; Important !!  Substract 4 us from CNT0 for first Data 
;******************************************************************************	
			movlw	CODE_LENGTH			; Code length from 64 to 72
			movwf	HOP_LENGTH			; Rx Counter for the Hopping Code!!	
;	
FIRST_KEELOQ_DATA
			movlw	.02					; Each value on CNT0 are 10uS
			subwf	CNT0,W				; Finetune the First sampling time
			movwf	CNT1				; save to CNT1 
			bcf		STATUS,C
			rrf		CNT1,F				; Check @ 1/2 TE location !!
;
PHASE_1_Delay			
			goto	$+1					;[2]  8uS delay time base for 1 TE
			goto	$+1 				;[2]
			nop							;[1]
			decfsz	CNT1,F				;[1]	
			goto	PHASE_1_Delay		;[2]	
			btfss	KEELOQ_IN			; Does Simple-Point "A" is high?
			goto	RECEIVE_Fail		; Still Low, Fail receive data	
;
			movf	CNT0,W				; Load TE value to CNT1 Reg.
			movwf	CNT1
PHASE_2_Delay
			goto	$+1					;[2]  8uS delay time base for 1 TE
			goto	$+1 				;[2]
			nop							;[1]
			decfsz	CNT1,F
			goto	PHASE_2_Delay		
;										; Sample KEELOQ Data Input & rotate buffer CSR0 to 8 here
			bcf		STATUS,C			; Assume Data is Logical 0
			btfss	KEELOQ_IN			; Is Logical 0 ??
			bsf		STATUS,C			; No , Set C as 1
			call	ROT_CSRs			; Store 1 bit Hopping data to [CSR0-8] Reg.
;
			movlw	0x02				; Fine-tune the TE
			subwf	CNT0,W
			movwf	CNT1
PHASE_3_Delay
			goto	$+1					;[2]  8uS delay time base for 1 TE
			goto	$+1 				;[2]
			nop							;[1]
			decfsz	CNT1,F
			goto	PHASE_3_Delay
			btfsc	KEELOQ_IN			; Test Sample-point "C", it must be Low Level
			goto	RECEIVE_Fail
;
			decfsz	HOP_LENGTH,F		; Check total Rx data langth?
			goto	To_Next_Bit			; Receive isn't complete yet, Continue receive
			goto	RECEIVE_A_FRAME		; Receive a complete hopping code
;
To_Next_Bit
			movf	CNT0,W
			movwf	CNT1
Phase_4_Delay
			btfsc	KEELOQ_IN			; [2] , is Rx signal equal high?
			goto	Init_For_Next		; Yes, receive next bit
			nop							; [1]
			goto	$+1					; [2]
			decfsz	CNT1,F				; [1]
			goto	Phase_4_Delay		; [2]	Delay 8uS time base for CNT0
			goto	RECEIVE_Fail		; over 1 TE that input signal still is low, Fail receive!
; 
Init_For_Next							; Reload CNT0 value to CNT1 for next bit comming
			movf	CNT0,W
			movwf	CNT1
			bcf		STATUS,C
			rrf		CNT1,F				; Wait 1/2 TE 
			goto	PHASE_1_Delay		
;

RECEIVE_A_FRAME
			movlw	(MAX_CODE_LENGTH - CODE_LENGTH)	; 72 - 66  = 6 bit
			xorlw	0x00
			btfsc	STATUS,Z
			goto	Rec_Exit						; Don't need shiht, return
;
			movwf	CNT1
ROT_Adjust	bcf		STATUS,C
			call	ROT_CSRs
			decfsz	CNT1,F
			goto	ROT_Adjust
;		
Rec_Exit	bsf		STATUS,C
			retlw	0x01
;
;*****************************************************
;****	Rotate CSRs register right 1 bit
;*****************************************************
ROT_CSRs
			RRF		CSR8,F
			RRF     CSR7,F
        	RRF     CSR6,F                    
        	RRF     CSR5,F                     
        	RRF     CSR4,F
        	RRF     CSR3,F                     
       	 	RRF     CSR2,F                     
        	RRF     CSR1,F                    
        	RRF     CSR0,F     
			return
;
;
;
;
;****************************************************************
;
; FUNCTION     	: DECRYPT ()	      			
;
; DESCRIPTION  	: DECRYPTS 32 BIT [HOP1:HOP4] USING [CSR0:CSR7]
;
;****************************************************************
DECRYPT
			BANKSEL	CNT1
        	MOVLW   (.11+1)         ; OUTER LOOP 11+1 TIMES 
        	MOVWF   CNT1          	; OUTER LOOP 11+1 TIMES 

DECRYPT_OUTER
        	MOVLW   .48             ; INNER LOOP 48 TIMES
        	MOVWF   CNT0          	; INNER LOOP 48 TIMES

DECRYPT_INNER
			CLRWDT					; RESET WATCHDOG TIMER
        	MOVFW   CNT1			; LAST 48 LOOPS RESTORE THE KEY
        	XORLW   .1              ; LAST 48 LOOPS RESTORE THE KEY
        	btfsc	STATUS,Z        ; LAST 48 LOOPS RESTORE THE KEY
        	GOTO    ROTATE_KEY      ; LAST 48 LOOPS RESTORE THE KEY

        ; THE LOOKUP TABLE IS COMPRESSED INTO IN 4 BYTES TO SAVE SPACE
        ; USE THE 3 LOW INDEX BITS TO MAKE UP AN 8-BIT BIT MASK
        ; USE THE 2 HIGH INDEX BITS TO LOOK UP THE VALUE IN THE TABLE
        ; USE THE BIT MASK TO ISOLATE THE CORRECT BIT IN THE BYTE
        ; PART OF THE REASON FOR THIS SCHEME IS BECAUSE NORMAL TABLE 
        ; LOOKUP REQUIRES AN ADDITIONAL STACK LEVEL
							
        	bcf	STATUS,C        	; CLEAR CARRY (FOR THE LEFT SHIFT)
       
        	MOVLW   .1              ; INITIALISE MASK = 1
        	BTFSC   HOP3,3       	; SHIFT MASK 4X IF BIT 2 SET
        	MOVLW   B'00010000'     ; SHIFT MASK 4X IF BIT 2 SET
        	MOVWF   MASK            ; INITIALISE MASK = 1

        	BTFSS   HOP2,0       	; SHIFT MASK ANOTHER 2X IF BIT 1 SET
        	GOTO    $+3
        	RLF     MASK,F
        	RLF     MASK,F            

        	BTFSC   HOP1,0       	; SHIFT MASK ANOTHER 1X IF BIT 0 SET
        	RLF     MASK,F

        ; MASK HAS NOW BEEN SHIFTED 0-7 TIMES ACCORDING TO BITS 2:1:0

			movlw	HIGH TABLE
			movwf	PCLATH

			movlw	LOW TABLE
			movwf	KEELOQ_Temp
		
        	MOVLW   0               ; TABLE INDEX = 0
        	BTFSC   HOP4,1
        	IORLW   .2              ; IF BIT 3 SET ADD 2 TO THE TABLE INDEX
        	BTFSC   HOP4,6
        	IORLW   .4              ; IF BIT 4 SET ADD 4 TO THE TABLE INDEX

			addwf	KEELOQ_Temp,W
			btfsc	STATUS,C
			incf	PCLATH,F
		
        	movwf	PCL           	; ADD THE INDEX TO THE PROGRAM COUNTER
									;  [ MUST BE IN LOWER HALF OF PAGE ]
                               
TABLE
        	MOVLW   0x2E            ; BITS 4:3 WERE 00
        	GOTO    TABLE_END       ; END OF LOOKUP

        	MOVLW   0x74            ; BITS 4:3 WERE 01
        	GOTO    TABLE_END       ; END OF LOOKUP

        	MOVLW   0x5C            ; BITS 4:3 WERE 10
        	GOTO    TABLE_END       ; END OF LOOKUP

        	MOVLW   0x3A            ; BITS 4:3 WERE 11
                                 
TABLE_END
        	ANDWF   MASK,1          ; ISOLATE THE CORRECT BIT
        	MOVLW   0               ; COPY THE BIT TO BIT 7
        	btfss	STATUS,Z        ; COPY THE BIT TO BIT 7
        	MOVLW   B'10000000'     ; COPY THE BIT TO BIT 7

        	XORWF   HOP2,W    		; ONLY INTERESTED IN BIT HOP2,7
        	XORWF   HOP4,W    		; ONLY INTERESTED IN BIT HOP4,7
        	XORWF   KEY1,W			; ONLY INTERESTED IN BIT KEYREG1,7

        	MOVWF   MASK            ; STORE W TEMPORARILY (WE NEED BIT 7)
        	RLF     MASK,F          ; LEFT ROTATE MASK TO GET BIT 7 INTO CARRY
	
        	RLF     HOP1,F         	; SHIFT IN THE NEW BIT
        	RLF     HOP2,F
        	RLF     HOP3,F
        	RLF     HOP4,F

ROTATE_KEY
        	bcf	STATUS,C			; CLEAR CARRY
        	BTFSC   KEY7,7       	; SET CARRY IF LEFTMOST BIT SET
        	bsf	STATUS,C       		; SET CARRY IF LEFTMOST BIT SET

        	RLF     KEY0,F         	; LEFT-ROTATE THE 64-BIT KEY 
        	RLF     KEY1,F
        	RLF     KEY2,F
        	RLF     KEY3,F
        	RLF     KEY4,F
        	RLF     KEY5,F
        	RLF     KEY6,F
        	RLF     KEY7,F         

        	DECFSZ  CNT0,F         	; INNER LOOP 48 TIMES
        	GOTO    DECRYPT_INNER   ; INNER LOOP 48 TIMES

        	DECFSZ  CNT1,F         	; OUTER LOOP 12 TIMES (11+1 TO RESTORE KEY)
        	GOTO    DECRYPT_OUTER   ; OUTER LOOP 12 TIMES (11+1 TO RESTORE KEY)

        	RETLW   0               ; RETURN 
;
			end						; End of Program Module !!
